
CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine transformmu(dipdx,dipdy,dipdz,uc
     $     ,numat,ddipQx,ddipQy,ddipQz,amass)


C     --------------------
C     transforms 
C     dipole derivatives are dipdx,dipdy,dipdz
C     --------------------
C     . nvar=nvarn in hessout, wenn in cart coord gearbeitet wird,
C       sonst ist nvar=n(interne coords.)
C     . in hessc existiert nvar sowieso nicht.
C     . AMASS ist ein vektor, auf dem die massen stehen wie:
C       masse (atom1) masse (atom1) masse(atom 1)
C       masse (atom2) masse (atom2) masse(atom 2)
C       masse (atom3) masse (atom3) masse(atom 3)
C       etc.
      implicit real*8 (a-h,o-z)
      INCLUDE 'param.h'

      real*8 uc(3*numat,3*numat)
      real*8 ddipQx(*)
      real*8 ddipQy(*)
      real*8 ddipQz(*)
      real*8 dipdx(*),dipdy(*),dipdz(*)
      real*8 amass(*)
      real*8 atoBohr

      AtoBohr = .52917726d0

C     laengster nach innen!
C     und da bilden wir ein vor-symmetrisiertes dipolmoment
C     mit intrinsischer ableitung...
      do mode = 7,3*numat
         ddipQx(mode)=0.d0
         ddipQy(mode)=0.d0
         ddipQz(mode)=0.d0
         i=0
         do i=1,3*numat
            ddipQx(mode)=ddipQx(mode)+dipdx(i)*uc(i,mode)
     $           /(sqrt(amass(i))/AtoBohr)
            ddipQy(mode)=ddipQy(mode)+dipdy(i)*uc(i,mode)
     $           /(sqrt(amass(i))/AtoBohr)
            ddipQz(mode)=ddipQz(mode)+dipdz(i)*uc(i,mode)
     $           /(sqrt(amass(i))/AtoBohr)
         enddo 
      enddo
      return
      end
